Index: /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_ubs.F90
===================================================================
--- /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_ubs.F90	(revision 790)
+++ /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_ubs.F90	(revision 791)
@@ -4,6 +4,6 @@
    !! Ocean tracers:  horizontal & vertical advective trend
    !!==============================================================================
-   !! History :  1.0  !  06-08  (L. Debreu, R. Benshila)  Original code
-   !!            2.4  !  08-01  (G. Madec) Merge TRA-TRC
+   !! History :  1.0  !  2006-08  (L. Debreu, R. Benshila)  Original code
+   !!            2.4  !  2008-01  (G. Madec)  merge TRC-TRA + switch from velocity to transport
    !!----------------------------------------------------------------------
 
@@ -27,6 +27,4 @@
    PUBLIC   tra_adv_ubs   ! routine called by traadv module
 
-   REAL(wp), DIMENSION(jpi,jpj) ::   e1e2tr   ! = 1/(e1t * e2t)
-
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -34,5 +32,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA & TRP 2.4 , LOCEAN-IPSL (2008) 
-   !! $Id:$ 
+   !! $Id$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
    !!----------------------------------------------------------------------
@@ -71,5 +69,5 @@
       !!
       !! Reference : Shchepetkin, A. F., J. C. McWilliams, 2005, Ocean Modelling, 9, 347-404. 
-      !!             Farrow, D.E., Stevens, D.P., 1995, J. Phys. Ocean. 25, 1731–1741. 
+      !!             Farrow, D.E., Stevens, D.P., 1995, J. Phys. Ocean. 25, 1731-1741. 
       !!----------------------------------------------------------------------
       INTEGER         , INTENT(in   )                         ::   kt              ! ocean time-step index
@@ -80,14 +78,13 @@
       REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pta             ! tracer trend 
       !!
-      INTEGER  ::   ji, jj, jk                 ! dummy loop indices
-      REAL(wp) ::   zta, zbtr, zcoef                  ! temporary scalars
-      REAL(wp) ::   zfui, zfp_ui, zfm_ui, zcenut      !    "         "
-      REAL(wp) ::   zfvj, zfp_vj, zfm_vj, zcenvt      !    "         "
-      REAL(wp) ::   z_hdivn                           !    "         "
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zeeu, zeev     ! temporary 2D workspace
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwx, zwy              ! temporary 3D workspace
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztu , ztv , zltu , zltv, ztrdt   !    "              "
-      !!----------------------------------------------------------------------
-
+      INTEGER  ::   ji, jj, jk                     ! dummy loop indices
+      REAL(wp) ::   zbtr, zcoef, z_hdivn           ! temporary scalars
+      REAL(wp) ::   zeeu, zfp_ui, zfm_ui, zcenut   !    "         "
+      REAL(wp) ::   zeev, zfp_vj, zfm_vj, zcenvt   !    "         "
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwx, ztu, zltu   ! temporary 3D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwy, ztv, zltv   !    "              "
+      !!----------------------------------------------------------------------
+
+!!gm  this can be optimized: we don't need zero everywhere
       zltu(:,:,:) = 0.e0
       zltv(:,:,:) = 0.e0
@@ -97,128 +94,75 @@
          IF(lwp) WRITE(numout,*) 'tra_adv_ubs :  horizontal UBS advection scheme'
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
-         !
-         e1e2tr(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
-      ENDIF
-
-      ! store pta trends
-      ztrdt(:,:,:) = pta(:,:,:)
-
-      zcoef = 1./6.
-      !                                                ! ===============
-      DO jk = 1, jpkm1                                 ! Horizontal slab
-         !                                             ! ===============
-
-         !  Initialization of metric arrays (for z- or s-coordinates)
+      ENDIF
+
+      !  Laplacian
+      DO jk = 1, jpkm1
+         DO jj = 1, jpjm1                               ! First derivative (gradient)
+            DO ji = 1, fs_jpim1   ! vector opt.
+               zeeu = e2u(ji,jj) * fse3u(ji,jj,jk) / e1u(ji,jj) * umask(ji,jj,jk)
+               zeev = e1v(ji,jj) * fse3v(ji,jj,jk) / e2v(ji,jj) * vmask(ji,jj,jk)
+               ztu(ji,jj,jk) = zeeu * ( ptb(ji+1,jj  ,jk) - ptb(ji,jj,jk) )
+               ztv(ji,jj,jk) = zeev * ( ptb(ji  ,jj+1,jk) - ptb(ji,jj,jk) )
+            END DO
+         END DO
+         DO jj = 2, jpjm1                               ! Second derivative (divergence)
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zcoef = 1. / ( 6. * fse3t(ji,jj,jk) )
+               zltu(ji,jj,jk) = (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk)  ) * zcoef
+               zltv(ji,jj,jk) = (  ztv(ji,jj,jk) - ztv(ji,jj-1,jk)  ) * zcoef
+            END DO
+         END DO
+      END DO
+
+      ! Lateral boundary conditions on the laplacian (zlt,zls)   (unchanged sgn)
+      CALL lbc_lnk( zltu, 'T', 1. )   ;    CALL lbc_lnk( zltv, 'T', 1. )
+
+
+      !  Horizontal advective fluxes
+      DO jk = 1, jpkm1
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-#if defined key_zco
-               ! z-coordinates, no vertical scale factors
-               zeeu(ji,jj) = e2u(ji,jj) / e1u(ji,jj) * umask(ji,jj,jk)
-               zeev(ji,jj) = e1v(ji,jj) / e2v(ji,jj) * vmask(ji,jj,jk)
-#else
-               ! s-coordinates, vertical scale factor are used
-               zeeu(ji,jj) = e2u(ji,jj) * fse3u(ji,jj,jk) / e1u(ji,jj) * umask(ji,jj,jk)
-               zeev(ji,jj) = e1v(ji,jj) * fse3v(ji,jj,jk) / e2v(ji,jj) * vmask(ji,jj,jk)
-#endif
-            END DO
-         END DO
-
-         !  Laplacian
-         ! First derivative (gradient)
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               ztu(ji,jj,jk) = zeeu(ji,jj) * ( ptb(ji+1,jj  ,jk) - ptb(ji,jj,jk) )
-               ztv(ji,jj,jk) = zeev(ji,jj) * ( ptb(ji  ,jj+1,jk) - ptb(ji,jj,jk) )
-            END DO
-         END DO
-         ! Second derivative (divergence)
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-#if ! defined key_zco
-               zcoef = 1. / ( 6. * fse3t(ji,jj,jk) )
-#endif         
-               zltu(ji,jj,jk) = (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk)  ) * zcoef
-               zltv(ji,jj,jk) = (  ztv(ji,jj,jk) - ztv(ji,jj-1,jk)  ) * zcoef
-            END DO
-         END DO
-         !                                             ! =================
-      END DO                                           !    End of slab
-      !                                                ! =================
-
-      ! Lateral boundary conditions on the laplacian (zlt,zls)   (unchanged sgn)
-      CALL lbc_lnk( zltu, 'T', 1. )   ;    CALL lbc_lnk( zltv, 'T', 1. )
-
-      !                                                ! ===============
-      DO jk = 1, jpkm1                                 ! Horizontal slab
-         !                                             ! ===============
-         !  Horizontal advective fluxes
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               ! volume fluxes * 1/2
-#if defined key_zco
-               zfui = 0.5 * e2u(ji,jj) * pun(ji,jj,jk)
-               zfvj = 0.5 * e1v(ji,jj) * pvn(ji,jj,jk)
-#else
-               zfui = 0.5 * e2u(ji,jj) * fse3u(ji,jj,jk) * pun(ji,jj,jk)
-               zfvj = 0.5 * e1v(ji,jj) * fse3v(ji,jj,jk) * pvn(ji,jj,jk)
-#endif
-               ! upstream scheme
-               zfp_ui = zfui + ABS( zfui )
-               zfp_vj = zfvj + ABS( zfvj )
-               zfm_ui = zfui - ABS( zfui )
-               zfm_vj = zfvj - ABS( zfvj )
+               ! upstream transport
+               zfp_ui = pun(ji,jj,jk) + ABS( pun(ji,jj,jk) )      ! = 2.pun  if pun>0,  =0      if pun<0
+               zfm_ui = pun(ji,jj,jk) - ABS( pun(ji,jj,jk) )      ! = 0      if pun>0,  = 2.pun if pun<0
+               zfp_vj = pvn(ji,jj,jk) + ABS( pvn(ji,jj,jk) )      ! idem on pvn
+               zfm_vj = pvn(ji,jj,jk) - ABS( pvn(ji,jj,jk) )      !
                ! centered scheme
-               zcenut = zfui * ( ptn(ji,jj,jk) + ptn(ji+1,jj  ,jk) )
-               zcenvt = zfvj * ( ptn(ji,jj,jk) + ptn(ji  ,jj+1,jk) )
-               ! mixed centered / upstream scheme
-               zwx(ji,jj,jk) = zcenut - zfp_ui * zltu(ji,jj,jk) -zfm_ui * zltu(ji+1,jj,jk)
-               zwy(ji,jj,jk) = zcenvt - zfp_vj * zltv(ji,jj,jk) -zfm_vj * zltv(ji,jj+1,jk)
-            END DO
-         END DO
-
-         !  Tracer flux divergence at t-point added to the general trend
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               ! horizontal advective trends
-#if defined key_zco
-               zbtr = e1e2tr(ji,jj)
-#else
-               zbtr = e1e2tr(ji,jj) / fse3t(ji,jj,jk)
-#endif
-               zta = - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk)   &
-                  &            + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk)  )
-               ! add it to the general tracer trends
-               pta(ji,jj,jk) = pta(ji,jj,jk) + zta
-            END DO
-         END DO
-         !                                             ! ===============
-      END DO                                           !   End of slab
-      !                                                ! ===============
-
-      ! Horizontal trend used in tra_adv_ztvd subroutine
-      zltu(:,:,:) = pta(:,:,:) - ztrdt(:,:,:) 
-
-      !  Save the horizontal advective trends for diagnostic
-      ! -----------------------------------------------------
-      IF( l_trdtra ) THEN
+               zcenut = pun(ji,jj,jk) * ( ptn(ji,jj,jk) + ptn(ji+1,jj  ,jk) )
+               zcenvt = pvn(ji,jj,jk) * ( ptn(ji,jj,jk) + ptn(ji  ,jj+1,jk) )
+               ! UBS scheme
+               zwx(ji,jj,jk) = 0.5 * (  zcenut - zfp_ui * zltu(ji,jj,jk) -zfm_ui * zltu(ji+1,jj,jk)  )
+               zwy(ji,jj,jk) = 0.5 * (  zcenvt - zfp_vj * zltv(ji,jj,jk) -zfm_vj * zltv(ji,jj+1,jk)  )
+            END DO
+         END DO
+      END DO
+
+      zltu(:,:,:) = pta(:,:,:)      ! store pta trends
+
+      ! Horizontal advective trends
+      DO jk = 1, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zbtr = 1.e0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               ! horizontal advective trends added to the general tracer trends
+               pta(ji,jj,jk) = pta(ji,jj,jk) - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk)   &
+                  &                                    + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk)  )
+            END DO
+         END DO
+      END DO
+
+      zltu(:,:,:) = pta(:,:,:) - zltu(:,:,:)    ! store the Horizontal advective trend (used in tra_adv_ztvd subroutine)
+
+ 
+      IF( l_trdtra ) THEN                       ! trend diagnostics (from advective fluxes)
          CALL trd_tra_adv( kt, ktra, jpt_trd_xad, cdtype, zwx, pun, ptn )
          CALL trd_tra_adv( kt, ktra, jpt_trd_yad, cdtype, zwy, pvn, ptn )
       ENDIF
-
-      ! "Poleward" heat or salt transport 
+      !                                         ! "Poleward" heat or salt transports
       IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
-         IF( lk_zco ) THEN
-            DO jk = 1, jpkm1
-               DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
-                    zwy(ji,jj,jk) = zwy(ji,jj,jk) * fse3v(ji,jj,jk)
-                  END DO
-               END DO
-            END DO
-         ENDIF
-         IF( ktra == jp_tem)   pht_adv(:) = ptr_vj( zwy(:,:,:) )
-         IF( ktra == jp_sal)   pst_adv(:) = ptr_vj( zwy(:,:,:) )
-      ENDIF
-
+         IF( ktra == jp_tem )   pht_adv(:) = ptr_vj( zwy(:,:,:) )
+         IF( ktra == jp_sal )   pst_adv(:) = ptr_vj( zwy(:,:,:) )
+      ENDIF
+      !                                         ! control print
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=pta, clinfo1=' ubs - had: ', mask1=tmask, clinfo3=cdtype )
 
@@ -226,22 +170,22 @@
       ! II. Vertical advection
       ! ----------------------
-      IF( l_trdtra )   ztrdt(:,:,:) = pta(:,:,:)          ! Save ta and sa trends
+      IF( l_trdtra )   zltv(:,:,:) = pta(:,:,:)          ! store pta if trend diag.
     
       ! TVD scheme the vertical direction  
       CALL tra_adv_ztvd( kt, pwn, zltu, ptb, ptn, pta )
 
-      IF( l_trdtra )   THEN         !  vertical advective trend diagnostics
-         DO jk = 1, jpkm1
+      IF( l_trdtra )   THEN                     ! vertical advective trend diagnostics
+         DO jk = 1, jpkm1                       ! (compute -w.dk[ptn]= -dk[w.ptn] + ptn.dk[w])
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  z_hdivn = (  pwn(ji,jj,jk) - pwn(ji,jj,jk+1)  ) / fse3t(ji,jj,jk)
-                  ztrdt(ji,jj,jk) = pta(ji,jj,jk) - ztrdt(ji,jj,jk+1)  +  ptn(ji,jj,jk) * z_hdivn 
+                  zbtr = 1.e0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  z_hdivn = (  pwn(ji,jj,jk) - pwn(ji,jj,jk+1)  ) * zbtr
+                  zltv(ji,jj,jk) = pta(ji,jj,jk) - zltv(ji,jj,jk+1)  +  ptn(ji,jj,jk) * z_hdivn 
                END DO
             END DO
          END DO
-         CALL trd_tra( kt, ktra, jpt_trd_zad, cdtype, ptrd3d=ztrdt )
-         !
-      ENDIF
-     
+         CALL trd_tra( kt, ktra, jpt_trd_zad, cdtype, ptrd3d=zltv )
+      ENDIF
+      !                                         ! control print
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=pta, clinfo1=' ubs - zad: ', mask1=tmask, clinfo3=cdtype )
       !
@@ -249,27 +193,26 @@
 
 
-   SUBROUTINE tra_adv_ztvd( kt, pwn, zttrd, ptb, ptn, pta )
+   SUBROUTINE tra_adv_ztvd( kt, pwn, phtrd, ptb, ptn, pta )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE tra_adv_ztvd  ***
       !! 
-      !! **  Purpose :   Compute the now trend due to total advection of 
-      !!       tracers and add it to the general trend of tracer equations
+      !! **  Purpose :   Compute the vertical advective trend of a tracer
+      !!               and add it to its general trend 
       !!
       !! **  Method  :   TVD scheme, i.e. 2nd order centered scheme with
       !!       corrected flux (monotonic correction)
-      !!       note: - this advection scheme needs a leap-frog time scheme
-      !!
-      !! ** Action : - update (ta,sa) with the now advective tracer trends
-      !!             - save the trends in (ztrdt,ztrds) ('key_trdtra')
-      !!----------------------------------------------------------------------
-      INTEGER , INTENT(in   )                         ::   kt      ! ocean time-step
-      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   pwn     ! verical effective velocity
-      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   zttrd   ! lateral advective trends on T & S 
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   ptb, ptn        ! before and now tracer fields
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pta             ! tracer trend 
+      !!
+      !! ** Action : - update pta with the vertical advective trend
+      !!             - trend diagnostic (lk_trdtra=T)
+      !!----------------------------------------------------------------------
+      INTEGER , INTENT(in   )                         ::   kt         ! ocean time-step
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   pwn        ! verical effective velocity
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   phtrd      ! lateral advective trends on T & S 
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   ptb, ptn   ! before and now tracer fields
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pta        ! tracer trend 
       !!
       INTEGER  ::   ji, jj, jk              ! dummy loop indices
-      REAL(wp) ::   z2dtt, zbtr, zew, z2    ! temporary scalar  
-      REAL(wp) ::   ztak, zfp_wk, zfm_wk            !    "         "
+      REAL(wp) ::   z2dtt, zbtr, z2         ! temporary scalar  
+      REAL(wp) ::   ztak, zfp_wk, zfm_wk    !    "         "
       REAL(wp), DIMENSION (jpi,jpj,jpk) ::   zti, ztw   ! temporary 3D workspace
       !!----------------------------------------------------------------------
@@ -285,26 +228,19 @@
       ENDIF
 
-      !  Bottom value : flux set to zero
-      ! --------------
-      ztw(:,:,jpk) = 0.e0   ;   zti  (:,:,:) = 0.e0
-
 
       !  upstream advection with initial mass fluxes & intermediate update
-      ! -------------------------------------------------------------------
-      ! Surface value
-      IF( lk_dynspg_rl .OR. lk_vvl ) THEN                           ! rigid lid : flux set to zero
-         ztw(:,:,1) = 0.e0
-      ELSE                                                          ! free surface
-         ztw(:,:,1) = e1t(:,:) * e2t(:,:) * pwn(:,:,1) * ptb(:,:,1)
-      ENDIF
-
-      ! Interior value
-      DO jk = 2, jpkm1
+      ztw(:,:,jpk) = 0.e0                                   ! Bottom  value : flux set to zero
+      zti(:,:,jpk) = 0.e0
+      !                                                     ! Surface value : 
+      IF( lk_dynspg_rl .OR. lk_vvl ) THEN   ;   ztw(:,:, 1 ) = 0.e0                      ! rigid lid or non-linear fs
+      ELSE                                  ;   ztw(:,:, 1 ) = pwn(:,:,1) * ptb(:,:,1)   ! linear free surface 
+      ENDIF
+      !
+      DO jk = 2, jpkm1                                      ! interior values
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zew = 0.5 * e1t(ji,jj) * e2t(ji,jj) * pwn(ji,jj,jk)
-               zfp_wk = zew + ABS( zew )
-               zfm_wk = zew - ABS( zew )
-               ztw(ji,jj,jk) = zfp_wk * ptb(ji,jj,jk) + zfm_wk * ptb(ji,jj,jk-1)
+               zfp_wk = pwn(ji,jj,jk) + ABS( pwn(ji,jj,jk) )
+               zfm_wk = pwn(ji,jj,jk) - ABS( pwn(ji,jj,jk) )
+               ztw(ji,jj,jk) = 0.5 * (  zfp_wk * ptb(ji,jj,jk) + zfm_wk * ptb(ji,jj,jk-1)  )
             END DO
          END DO
@@ -318,42 +254,33 @@
                zbtr = 1./ ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
                ztak = - ( ztw(ji,jj,jk) - ztw(ji,jj,jk+1) ) * zbtr
-               pta(ji,jj,jk) =  pta(ji,jj,jk) + ztak
-               zti (ji,jj,jk) = ( ptb(ji,jj,jk) + z2dtt * ( ztak + zttrd(ji,jj,jk) ) ) * tmask(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-
-      ! Lateral boundary conditions on zti, zsi   (unchanged sign)
-      CALL lbc_lnk( zti, 'T', 1. )
+               pta(ji,jj,jk) =   pta(ji,jj,jk) +           ztak
+               zti(ji,jj,jk) = ( ptb(ji,jj,jk) + z2dtt * ( ztak + phtrd(ji,jj,jk) ) ) * tmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      !
+      CALL lbc_lnk( zti, 'T', 1. )      ! Lateral boundary conditions on zti, zsi   (unchanged sign)
 
 
       !  antidiffusive flux : high order minus low order
-      ! -------------------------------------------------      
       ztw(:,:,1) = 0.e0       ! Surface value
-
       DO jk = 2, jpkm1        ! Interior value
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zew = 0.5 * e1t(ji,jj) * e2t(ji,jj) * pwn(ji,jj,jk)
-               ztw(ji,jj,jk) = zew * ( ptn(ji,jj,jk) + ptn(ji,jj,jk-1) ) - ztw(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-
-      !  monotonicity algorithm
-      ! ------------------------
-      CALL nonosc_z( ptb, ztw, zti, z2 )
+               ztw(ji,jj,jk) = 0.5 * pwn(ji,jj,jk) * ( ptn(ji,jj,jk) + ptn(ji,jj,jk-1) ) - ztw(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      !
+      CALL nonosc_z( ptb, ztw, zti, z2 )      !  monotonicity algorithm
 
 
       !  final trend with corrected fluxes
-      ! -----------------------------------
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.  
                zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-               ! k- vertical advective trends
-               ztak = - ( ztw(ji,jj,jk) - ztw(ji,jj,jk+1) ) * zbtr
-               ! add them to the general tracer trends
-               pta(ji,jj,jk) = pta(ji,jj,jk) + ztak
+               ! k- vertical advective trends added to the general tracer trends
+               pta(ji,jj,jk) = pta(ji,jj,jk) - ( ztw(ji,jj,jk) - ztw(ji,jj,jk+1) ) * zbtr
             END DO
          END DO
